%define gcj_support 1
%define jmailver 1.3.2
%define inetlibver 1.1.1

Name:           classpathx-mail
Version:        1.1.1
Release:        %mkrel 3
Epoch:          0
Summary:        GNU JavaMail(tm)

Group:          Development/Java
License:        LGPL-like
URL:            http://www.gnu.org/software/classpathx/javamail/javamail.html
Source0:        http://ftp.gnu.org/gnu/classpathx/mail-%{version}.tar.bz2
Source1:        http://ftp.gnu.org/gnu/classpath/inetlib-%{inetlibver}.tar.bz2
Patch0:         %{name}-crosslink.patch.bz2
Patch1:         %{name}-docbuild.patch.bz2
Patch2:         %{name}-add-inetlib.patch.bz2
Patch3:         classpath-inetlib-crosslink.patch.bz2
Patch4:         classpath-inetlib-docbuild.patch.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
#Vendor:         JPackage Project
#Distribution:   JPackage
%if %{gcj_support}
Requires(post):	java-gcj-compat
Requires(postun): java-gcj-compat
BuildRequires:	java-gcj-compat-devel
# aot compile is in monolithic jar only
Requires:	%{name}-monolithic = %{epoch}:%{version}-%{release}
%else
BuildArch:      noarch
%endif
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  ant >= 0:1.6
BuildRequires:  jaf >= 0:1.1
BuildRequires:  %{_bindir}/perl
BuildRequires:  jce
BuildRequires:  java-sasl
Requires:       jaf >= 0:1.1
Requires:       jce
Requires:       java-sasl
Provides:       javamail = 0:%{jmailver}
# RHEL3 and FC2
#Obsoletes:	javamail >= 0:20000000

%description
GNU JavaMail(tm) is a free implementation of the JavaMail API.

%package monolithic
Summary:       All of %{name} in one monolithic jar
Group:         Development/Java
Requires:       jaf >= 0:1.1
Requires:       jce
Requires:       java-sasl
Provides:       javamail-monolithic = 0:%{jmailver}

%description monolithic
All of %{name} in one monolithic jar.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Java
Provides:       javamail-javadoc = 0:%{jmailver}
BuildRequires:  java-javadoc, jaf-javadoc

%description    javadoc
%{summary}.


%prep
%setup -q -n mail-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
rm -f libmail.so
%{__bzip2} -dc %{SOURCE1} | %{__tar} -xf -
pushd inetlib-%{inetlibver}
%patch3 -p1
%patch4 -p1
  mkdir -p source/org/jpackage/mail
  mv source/gnu/inet source/org/jpackage/mail
popd
# assume no filename contains spaces
perl -p -i -e 's/gnu(.)inet/org${1}jpackage${1}mail${1}inet/' `grep gnu.inet -lr *`


%build
# build inetlib
pushd inetlib-%{inetlibver}
  export CLASSPATH=$(build-classpath jaf jce sasl 2>/dev/null)
  %ant -Dj2se.apidoc=%{_javadocdir}/java inetlib.jar doc
popd
mkdir classes
cp -a inetlib-%{inetlibver}/classes/org classes
# build mail
%ant \
  -Dactivation.jar=$(build-classpath activation) \
  -Dinetlib.jar=`pwd`/inetlib-%{inetlibver}/inetlib.jar \
  -Dj2se.apidoc=%{_javadocdir}/java \
  -Djaf.apidoc=%{_javadocdir}/jaf \
  dist javadoc
# build monolithic
mkdir monolithic
pushd monolithic
for jar in gnumail-providers gnumail; do %{jar} xf ../$jar.jar; done
rm -f META-INF/MANIFEST.MF
%{jar} cf ../monolithic.jar *
popd
rm -Rf monolithic


%install
rm -rf $RPM_BUILD_ROOT

install -dm 755 $RPM_BUILD_ROOT%{_javadir}/javamail
install -pm 644 gnumail.jar \
  $RPM_BUILD_ROOT%{_javadir}/javamail/mailapi-%{jmailver}.jar
ln -s mailapi-%{jmailver}.jar $RPM_BUILD_ROOT%{_javadir}/javamail/mailapi.jar

install -pm 644 gnumail-providers.jar \
  $RPM_BUILD_ROOT%{_javadir}/javamail/gnumail-providers-%{jmailver}.jar
ln -s gnumail-providers-%{jmailver}.jar \
  $RPM_BUILD_ROOT%{_javadir}/javamail/gnumail-providers.jar
for prov in imap nntp pop3 smtp ; do
  ln -s gnumail-providers.jar $RPM_BUILD_ROOT%{_javadir}/javamail/$prov.jar
  ln -s gnumail-providers-%{jmailver}.jar \
    $RPM_BUILD_ROOT%{_javadir}/javamail/$prov-%{jmailver}.jar
done

install -pm 644 monolithic.jar \
  $RPM_BUILD_ROOT%{_javadir}/javamail-%{jmailver}.jar
ln -s javamail-%{jmailver}.jar $RPM_BUILD_ROOT%{_javadir}/javamail.jar

install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/javamail-%{jmailver}
cp -pR docs/* $RPM_BUILD_ROOT%{_javadocdir}/javamail-%{jmailver}
ln -s javamail-%{jmailver} $RPM_BUILD_ROOT%{_javadocdir}/javamail

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{gcj_support}
%post
%{update_gcjdb}

%postun
%{clean_gcjdb}
%endif

%post javadoc
rm -f %{_javadocdir}/javamail
ln -s javamail-%{jmailver} %{_javadocdir}/javamail


%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog COPYING
%{_javadir}/javamail

%files monolithic
%defattr(644,root,root,755)
%{_javadir}/javamail-%{jmailver}.jar
%{_javadir}/javamail.jar
%dir %{_libdir}/gcj/%{name}
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/javamail-%{jmailver}.jar.*
%endif

%files javadoc
%defattr(644,root,root,755)
%doc %{_javadocdir}/javamail-%{jmailver}
%ghost %doc %{_javadocdir}/javamail


%changelog
* Fri Aug 04 2006 David Walluck <walluck@mandriva.org> 0:1.1.1-3mdv2007.0
- fix BuildRequires

* Wed May 24 2006 David Walluck <walluck@mandriva.org> 0:1.1.1-2mdv2007.0
- update URL
- use %%{jar} macro
- rebuild for libgcj.so.7

* Sat Nov 12 2005 David Walluck <walluck@mandriva.org> 0:1.1.1-1mdk
- 1.1.1

* Fri Oct 21 2005 David Walluck <walluck@mandriva.org> 0:1.0-4.2mdk
- add monolithic jar

* Wed May 11 2005 David Walluck <walluck@mandriva.org> 0:1.0-4.1mdk
- release

* Mon May 02 2005 Jason Corley <jason.corley@gmail.com> 0:1.0-4jpp
- Rebuild

* Thu Oct 28 2004 Thomas Fitzsimmons <fitzsim@redhat.com> 0:1.0-3jpp
- Don't require classpath-inetlib.
- Require java-sasl and jce.
- Replace gnu.inet references with org.jpackage.mail.inet.
- Build inetlib.
- Include inetlib in providers.jar.

* Sat Jul  3 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-2jpp
- Require classpath-inetlib and jaf.

* Tue Jun 15 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-1jpp
- First build.
